#include "ContactListener.h"

ContactListener::ContactListener()
{
    k_maxContactPoints = 2048;
    m_points = new ContactPoint [k_maxContactPoints];
}

ContactListener::~ContactListener()
{
    delete[] m_points;
}

void ContactListener::Add(const b2ContactPoint* point)
{
	if (m_pointCount == k_maxContactPoints)
	{
		return;
	}

	ContactPoint* cp = m_points + m_pointCount;
	cp->shape1 = point->shape1;
	cp->shape2 = point->shape2;
	cp->position = point->position;
	cp->normal = point->normal;
	cp->id = point->id;
	cp->state = e_contactAdded;

	++m_pointCount;
}

void ContactListener::Persist(const b2ContactPoint* point)
{
	if (m_pointCount == k_maxContactPoints)
	{
		return;
	}

	ContactPoint* cp = m_points + m_pointCount;
	cp->shape1 = point->shape1;
	cp->shape2 = point->shape2;
	cp->position = point->position;
	cp->normal = point->normal;
	cp->id = point->id;
	cp->state = e_contactPersisted;

	++m_pointCount;
}

void ContactListener::Remove(const b2ContactPoint* point)
{
	if (m_pointCount == k_maxContactPoints)
	{
		return;
	}

	ContactPoint* cp = m_points + m_pointCount;
	cp->shape1 = point->shape1;
	cp->shape2 = point->shape2;
	cp->position = point->position;
	cp->normal = point->normal;
	cp->id = point->id;
	cp->state = e_contactRemoved;

	++m_pointCount;
}

bool ContactListener::IsShapesContact(b2Shape* first, b2Shape* second)
{
    for (int32 i = 0; i < m_pointCount; ++i)
    {
        ContactPoint* point = m_points + i;

        if (point->state == 2)
        {
            continue;
        }

        if ((point->shape1 == first && point->shape2==second) || (point->shape1 == second && point->shape2==first))
        {
            return true;
        }
    }
    return false;
}
