#ifndef CONTACTLISTENER_H_INCLUDED
#define CONTACTLISTENER_H_INCLUDED
#include "Box2D.h"
// целиком из TestBed
enum ContactState
{
	e_contactAdded,
	e_contactPersisted,
	e_contactRemoved,
};

struct ContactPoint
{
	b2Shape* shape1;
	b2Shape* shape2;
	b2Vec2 normal;
	b2Vec2 position;
	b2Vec2 velocity;
	b2ContactID id;
	ContactState state;
};

class ContactListener : public b2ContactListener
{
public:
    ContactListener();
    ~ContactListener();
	void Add(const b2ContactPoint* point);
	void Persist(const b2ContactPoint* point);
	void Remove(const b2ContactPoint* point);
	int32 k_maxContactPoints;
	ContactPoint *m_points;
    int32 m_pointCount;
    bool IsShapesContact(b2Shape*, b2Shape*);
};



#endif // CONTACTLISTENER_H_INCLUDED
