#include "Table.h"

void sensor_info::clear(int number)
{
    active=false;
    multiplier=number;
    ball_in_me=false;
}

int random_special(int a, int b)
{
    return (rand()%(abs(a)+b))+a;
}

float find_dist(x_y a, x_y b)
{
    return sqrt(pow(a.x-b.x,2)+pow(a.y-b.y,2));
}

float get_direction(x_y a, x_y b)
{
    float direction=atan((b.y-a.y)/(b.x-a.x));
    if(a.x-b.x>0) direction+=M_PI;
    return direction;
}

RandomDB::RandomDB()
{
    number_of_circle_bouncing=rand()%10+12;
    // для равномерности
    allCircleStaticCoords[0].x=random_special(-496,-256);
    allCircleStaticCoords[0].y=rand()%100+260;
    allCircleStaticCoords[1].x=random_special(-256,-16);
    allCircleStaticCoords[1].y=rand()%100+260;
    allCircleStaticCoords[2].x=random_special(-496,-256);
    allCircleStaticCoords[2].y=rand()%100+160;
    allCircleStaticCoords[3].x=random_special(-256,-16);
    allCircleStaticCoords[3].y=rand()%100+160;
    allCircleStaticCoords[4].x=random_special(-496,-256);
    allCircleStaticCoords[4].y=rand()%100+60;
    allCircleStaticCoords[5].x=random_special(-256,-16);
    allCircleStaticCoords[5].y=rand()%100+60;
    allCircleStaticCoords[6].x=random_special(-496,-256);
    allCircleStaticCoords[6].y=random_special(-40,60);
    allCircleStaticCoords[7].x=random_special(-256,-16);
    allCircleStaticCoords[7].y=random_special(-40,60);
    allCircleStaticCoords[8].x=random_special(-496,-256);
    allCircleStaticCoords[8].y=random_special(-40,-140);
    allCircleStaticCoords[9].x=random_special(-256,-16);
    allCircleStaticCoords[9].y=random_special(-40,-140);
    for(int i=10; i<number_of_circle_bouncing; i++)
    {
        allCircleStaticCoords[i].x=random_special(-496,-16);
        allCircleStaticCoords[i].y=random_special(-250,360);
        for(int j=0; j<i; j++)
        {
            if(find_dist(allCircleStaticCoords[i], allCircleStaticCoords[j])<20)
            {
                i--;
                break;
            }
        }
    }
    up = M_PI/2.0;
    lenght = rand()%100+200;
    delta = (rand()%20+15)/100.0;

    for(int i=0; i<7; i++)
        randomers_sensors[i]=rand()%5+2;

}

RandomDB::~RandomDB()
{
    delete allCircleStaticCoords;
}

Table::~Table()
{
    delete world;
}

Table::Table(int i)
{
    this->i=i;

    automatic=true;
    name_of_player="Buhjr"; // бухшжр
    score=0;

    balls_created=0;

    lobeLeftUp=false;
    lobeRightUp=false;

    b2AABB worldAABB;
    worldAABB.lowerBound.Set(-512+512*i, -384);
	worldAABB.upperBound.Set(0+512*i, 450);

    b2Vec2 gravity(0.0f, -50.0f);

	bool doSleep = true;

    world=new b2World(worldAABB, gravity, doSleep);

    b2BodyDef groundBodyDef;
    b2PolygonDef groundShapeDef;
// нижний
    groundBodyDef.position.Set(-256+512*i, -382.0f);
    groundBody = world->CreateBody(&groundBodyDef);
    groundShapeDef.restitution = 0.1;
	groundShapeDef.SetAsBox(254, 2.0f);
    groundBody->CreateShape(&groundShapeDef);

// верхний
    groundBodyDef.position.Set(-256+512*i, 382.0);
    groundBody = world->CreateBody(&groundBodyDef);
    groundBody->CreateShape(&groundShapeDef);

// левый
    groundBodyDef.position.Set(-510+512*i, 0);
    groundBody = world->CreateBody(&groundBodyDef);
	groundShapeDef.SetAsBox(2, 382);
    groundBody->CreateShape(&groundShapeDef);

// правый
    groundBodyDef.position.Set(-2+512*i, 0.0);
    groundBody = world->CreateBody(&groundBodyDef);
    groundBody->CreateShape(&groundShapeDef);

// правый треугольник, для скатывания вниз
    b2PolygonDef triangleShapeDef;
    groundBodyDef.position.Set(-2+512*i, -340);
    triangleShapeDef.vertexCount = 3;
    triangleShapeDef.vertices[0].Set(0, 0);
    triangleShapeDef.vertices[1].Set(0.0f, 80);
    triangleShapeDef.vertices[2].Set(-192, 0.0f);
    groundBody = world->CreateBody(&groundBodyDef);
    groundBody->CreateShape(&triangleShapeDef);

// левый треугольник
    groundBodyDef.position.Set(-510+512*i, -340);
    triangleShapeDef.vertices[0].Set(0, 0);
    triangleShapeDef.vertices[1].Set(192, 0.0);
    triangleShapeDef.vertices[2].Set(0.0, 80.0f);
    groundBody = world->CreateBody(&groundBodyDef);
    groundBody->CreateShape(&triangleShapeDef);

// сенсор
    groundBodyDef.position.Set(-256+512*i, -362);
    sensorBody = world->CreateBody(&groundBodyDef);
    groundShapeDef.isSensor = true;
    groundShapeDef.SetAsBox(256,22);
    sensorBody->CreateShape(&groundShapeDef);

 	//делаем лепестки
	// правый
	{
	    b2BodyDef anyDef;
	    b2PolygonDef anyShape;
        b2PolygonDef triangleShape;

        anyDef.position.Set(-134+512*i, -214);
        groundBody = world->CreateBody(&anyDef);
        triangleShape.vertexCount = 3;
        triangleShape.vertices[0].Set(0, 0);
        triangleShape.vertices[1].Set(0, 80);
        triangleShape.vertices[2].Set(-48, -20);
        groundBody->CreateShape(&triangleShape);

        // штучка трианглес
        anyDef.position.Set(-158+512*i, -185);
        anyDef.angle = -atan(48/100.0);
        groundBody = world->CreateBody(&anyDef);
        anyShape.SetAsBox(0.5,53);
        anyShape.restitution = 10;
        groundBody->CreateShape(&anyShape);

        anyDef.position.Set(-51+512*i, -168);
        anyDef.angle = 0;
        groundBody = world->CreateBody(&anyDef);
        anyShape.SetAsBox(2, 80);
        anyShape.restitution = 0;
        groundBody->CreateShape(&anyShape);

	    anyDef.position.Set(-112+512*i,-265);
	    anyDef.angle = 0.395;
	    groundBody = world->CreateBody(&anyDef);
	    anyShape.filter.groupIndex=-1;
	    anyShape.SetAsBox(67, 8);
	    groundBody->CreateShape(&anyShape);

	    anyDef.position.Set(-190+512*i, -298);
	    //anyDef.massData.mass=1000;
	    lobeBodyForRight = world->CreateBody(&anyDef);

	    anyShape.density=0.20;
	    anyShape.friction=0.1;
	    anyShape.restitution=1;
	    anyShape.SetAsBox(30, 8);
        lobeBodyForRight->CreateShape(&anyShape);
        lobeBodyForRight->SetMassFromShapes();

        b2RevoluteJointDef jointDef;
	    b2Vec2 dotofcontact(-169+512*i,-289);
        jointDef.Initialize(groundBody, lobeBodyForRight, dotofcontact);
        jointDef.lowerAngle = -1.0;
        jointDef.upperAngle = 0.0;
        jointDef.enableLimit = true;

        world->CreateJoint(&jointDef);

        // делаем шар - область в влетание в которую заставит ИИ действовать
        anyDef.position.Set(-215+512*i,-295);
        aiActionBodyRight = world->CreateBody(&anyDef);
        b2CircleDef circle;
        circle.radius=17;
        circle.isSensor = true;
        aiActionBodyRight->CreateShape(&circle);

	}

	// левый лепесток
    {
	    b2BodyDef anyDef;
	    b2PolygonDef anyShape;
        b2PolygonDef triangleShape;

        anyDef.position.Set(-378+512*i, -214);
        groundBody = world->CreateBody(&anyDef);
        triangleShape.vertexCount = 3;
        triangleShape.vertices[0].Set(0, 0);
        triangleShape.vertices[1].Set(48, -20);
        triangleShape.vertices[2].Set(0, 80);
        groundBody->CreateShape(&triangleShape);

        // штучка от которой оталкивается
        anyDef.position.Set(-354+512*i, -185);
        anyDef.angle = atan(48/100.0);
        groundBody = world->CreateBody(&anyDef);
        anyShape.SetAsBox(0.5,53);
        anyShape.restitution = 10;
        groundBody->CreateShape(&anyShape);

        anyDef.position.Set(-461+512*i, -168);
        anyDef.angle = 0;
        groundBody = world->CreateBody(&anyDef);
        anyShape.SetAsBox(2, 80);
        anyShape.restitution = 0;
        groundBody->CreateShape(&anyShape);

	    anyDef.position.Set(-400+512*i,-265);
	    anyDef.angle = -0.395;
	    groundBody = world->CreateBody(&anyDef);
	    anyShape.filter.groupIndex=-1;
	    anyShape.SetAsBox(67, 8);
	    groundBody->CreateShape(&anyShape);

	    anyDef.position.Set(-322+512*i, -298);
	    //anyDef.massData.mass=1000;
	    lobeBodyForLeft = world->CreateBody(&anyDef);

	    anyShape.density=0.20;
	    anyShape.friction=0.1;
	    anyShape.restitution=1;
	    anyShape.SetAsBox(30, 8);
        lobeBodyForLeft->CreateShape(&anyShape);
        lobeBodyForLeft->SetMassFromShapes();

        b2RevoluteJointDef jointDef;
        b2Vec2 dotofcontact(-343+512*i,-289);
        jointDef.Initialize(groundBody, lobeBodyForLeft, dotofcontact);
        jointDef.lowerAngle = 0.0;
        jointDef.upperAngle = 1.0;
        jointDef.enableLimit = true;

        world->CreateJoint(&jointDef);

        // делаем шар - область в влетание в которую заставит ИИ действовать
        anyDef.position.Set(-297+512*i,-295);
        aiActionBodyLeft = world->CreateBody(&anyDef);
        b2CircleDef circle;
        circle.radius=17;
        circle.isSensor = true;
        aiActionBodyLeft->CreateShape(&circle);
	}
    world->SetDebugDraw(&Draw);
    world->SetContactListener(&CListen);
}

void Table::Set(RandomDB *db, bool ex_automatic)
{
    score = 0;

    CreateBall();

    for(int j=0; j<7; j++)
        sens_info[j].clear(db->randomers_sensors[j]);

    automatic=ex_automatic;
    //RandomDB randdb=ex_db;
    numberAllStaticCircles=db->number_of_circle_bouncing;
    allStaticCircles = new b2Body* [numberAllStaticCircles];
    {
        b2BodyDef Def;
        b2CircleDef Shape;

        for(int i=0; i<numberAllStaticCircles; i++)
        {
            Def.position.Set(db->allCircleStaticCoords[i].x+this->i*512, db->allCircleStaticCoords[i].y);
            allStaticCircles[i]=world->CreateBody(&Def);
            Shape.radius=7.5;
            Shape.density=20;
            Shape.restitution=2;
            Shape.friction=0.1;
            allStaticCircles[i]->CreateShape(&Shape);
        }
    }
    {
        for(int j=0; j<5; j++)
        {
            numberAllDynamicSquares[j]=(int)(find_dist(db->allCircleStaticCoords[2*j], db->allCircleStaticCoords[2*j+1])/30.0);
            if(numberAllDynamicSquares[j]<2) numberAllDynamicSquares[j]=3;
            allDynamicSquares[j] = new b2Body* [numberAllDynamicSquares[j]];
            float direction = get_direction(db->allCircleStaticCoords[2*j], db->allCircleStaticCoords[2*j+1]);

            b2BodyDef bodyDef;
            b2PolygonDef bodyShape;

            for(int i=0; i<numberAllDynamicSquares[j]; i++)
            {
                bodyDef.position.Set(db->allCircleStaticCoords[2*j].x+29*(i+1)*cos(direction)+512*this->i,
                                     db->allCircleStaticCoords[2*j].y+29*(i+1)*sin(direction));
                bodyDef.angularDamping=0.5;
                allDynamicSquares[j][i] = world->CreateBody(&bodyDef);
                bodyShape.SetAsBox(5.0f, 5.0f);
                bodyShape.density = 0.00002f;
                bodyShape.friction = 0.1f;
                allDynamicSquares[j][i]->CreateShape(&bodyShape);
                allDynamicSquares[j][i]->SetMassFromShapes();
            }

            b2DistanceJointDef jointDef[numberAllDynamicSquares[j]+1];
            jointDef[0].collideConnected = true;
            jointDef[0].length = 30;
            jointDef[0].Initialize(allStaticCircles[2*j],
                                   allDynamicSquares[j][0],
                                   allStaticCircles[2*j]->GetWorldCenter(),
                                   allDynamicSquares[j][0]->GetWorldCenter());

            world->CreateJoint(&jointDef[0]);

            for(int i=1; i<numberAllDynamicSquares[j]; i++)
            {
                jointDef[i].collideConnected = true;
                jointDef[i].length = 30;
                jointDef[i].Initialize(allDynamicSquares[j][i-1],
                                       allDynamicSquares[j][i],
                                       allDynamicSquares[j][i-1]->GetWorldCenter(),
                                       allDynamicSquares[j][i]->GetWorldCenter());
                world->CreateJoint(&jointDef[i]);
            }
        //
            jointDef[numberAllDynamicSquares[j]].collideConnected = true;
            jointDef[numberAllDynamicSquares[j]].length = 30;
            jointDef[numberAllDynamicSquares[j]].Initialize(allStaticCircles[2*j+1],
                                                            allDynamicSquares[j][numberAllDynamicSquares[j]-1],
                                                            allStaticCircles[2*j+1]->GetWorldCenter(),
                                                            allDynamicSquares[j][numberAllDynamicSquares[j]-1]->GetWorldCenter());
            world->CreateJoint(&jointDef[numberAllDynamicSquares[j]]);
        }
    }

    // кучка сенсоров множителей
    {
        b2BodyDef circle;
        b2CircleDef circleDef;
        circleDef.radius = 6.00f;
        circleDef.isSensor = true;

        int j=0;
        circle.userData = &sens_info[j];
        circle.position.Set(-256+512*i+db->lenght*cos(db->up), -300+db->lenght*sin(db->up));
        sensors[j] = world->CreateBody( &circle );
        sensors[j]->CreateShape(&circleDef);
        j++;

        float plus_delta=db->delta;
        for(; j<4; j++)
        {
            circle.userData = &sens_info[j];
            circle.position.Set(-256+512*i+db->lenght*cos(db->up+plus_delta), -300+db->lenght*sin(db->up+plus_delta));
            sensors[j] = world->CreateBody( &circle );
            sensors[j]->CreateShape(&circleDef);
            plus_delta+=db->delta;
        }
//
        float minus_delta=-db->delta;
        for(; j<7; j++)
        {
            circle.userData = &sens_info[j];
            circle.position.Set(-256+512*i+db->lenght*cos(db->up+minus_delta), -300+db->lenght*sin(db->up+minus_delta));
            sensors[j] = world->CreateBody( &circle );
            sensors[j]->CreateShape(&circleDef);
            minus_delta-=db->delta;
        }
    }

    Flush();
}

void Table::CreateBall()
{
    if(balls_created==100) return;

        b2BodyDef ballDef;
        b2CircleDef ballCircleDef;
        ballDef.position.Set(random_special(-496,-16)+512*i, 365);
        ballDef.angularDamping=0.8;
        ballDef.isBullet = true;
        ballBody[balls_created] = world->CreateBody( &ballDef );
        ballCircleDef.radius = 5.43f;
        ballCircleDef.friction = 0.1;
        ballCircleDef.density = 0.0001;
        ballCircleDef.restitution = 0.4;
        ballBody[balls_created]->CreateShape(&ballCircleDef);
        ballBody[balls_created]->SetMassFromShapes();

    balls_created++;
}

void Table::Step(float32 time, int32 iters)
{
    static b2Vec2 forceUP(0,550000);
    static b2Vec2 forceDOWN(0,-200000);

//    DrawAABB(&worldAABB,b2Color(255,255,255));
    Draw.SetFlags(b2DebugDraw::e_shapeBit);
    world->Step(time, iters);

    if(lobeLeftUp) lobeBodyForLeft->ApplyForce(lobeBodyForLeft->GetWorldVector(forceUP), lobeBodyForLeft->GetWorldPoint(b2Vec2(30,0)));
    else lobeBodyForLeft->ApplyForce(lobeBodyForLeft->GetWorldVector(forceDOWN), lobeBodyForLeft->GetWorldPoint(b2Vec2(30,0)));

    if(lobeRightUp) lobeBodyForRight->ApplyForce(lobeBodyForRight->GetWorldVector(forceUP), lobeBodyForRight->GetWorldPoint(b2Vec2(-30,0)));
    else lobeBodyForRight->ApplyForce(lobeBodyForRight->GetWorldVector(forceDOWN), lobeBodyForRight->GetWorldPoint(b2Vec2(-30,0)));

    int multiplier=1;

    for(int j=0; j<5; j++)
    {
        for(int i=0; i<numberAllDynamicSquares[j]; i++)
        {
            if(allDynamicSquares[j][i]!=NULL)
            {
                break;
            }

            if(i==numberAllDynamicSquares[j]-1)
            {
                multiplier+=1;
                break;
            }
        }
    }

    for(int i=0; i<7; i++)
    {
        sensor_info* info = (sensor_info*) sensors[i]->GetUserData();
        if(info->active) multiplier+=info->multiplier;
    }

    for(int k=0; k<balls_created; k++)
    {
        for(int i=0; i<7; i++)
        {
            sensor_info* info = (sensor_info*) sensors[i]->GetUserData();
            if(info->ball_in_me)
            {
                if(!CListen.IsShapesContact(sensors[i]->GetShapeList(), ballBody[k]->GetShapeList()))
                {
                    info->ball_in_me=false;
                }
            }
            else
            {
                if(CListen.IsShapesContact(sensors[i]->GetShapeList(), ballBody[k]->GetShapeList()))
                {
                    info->ball_in_me=true;
                    info->active=!info->active;
                }
            }
        }

        for(int j=0; j<5; j++)
        {
            for(int i=0; i<numberAllDynamicSquares[j]; i++)
            {
                if(allDynamicSquares[j][i]!=NULL)
                    if(CListen.IsShapesContact(allDynamicSquares[j][i]->GetShapeList(), ballBody[k]->GetShapeList()))
                    {
                        score+=100*multiplier;
                        world->DestroyBody(allDynamicSquares[j][i]);
                        allDynamicSquares[j][i]=NULL;
                    }
            }
        }

        for(int i=0; i<numberAllStaticCircles; i++)
        {
            if(CListen.IsShapesContact(allStaticCircles[i]->GetShapeList(), ballBody[k]->GetShapeList()))
                score+=20*multiplier;
        }

        // ИИ
        if(automatic)
        {
            if(CListen.IsShapesContact(aiActionBodyRight->GetShapeList(), ballBody[k]->GetShapeList()))
            {
                Control(sright);
            }
            else ControlLost(sright);
            if(CListen.IsShapesContact(aiActionBodyLeft->GetShapeList(), ballBody[k]->GetShapeList()))
            {
                Control(sleft);
            }
            else ControlLost(sleft);
        }
    }

    if(score/10000.0>balls_created) CreateBall();

    DrawObjects(multiplier);
}

void Table::DrawObjects(int mult)
{
    glColor3ub(244,244,244);
    freetype::print(font, -500+512*i, 360, str_score.c_str(), name_of_player.c_str(), score, mult);

    // рисуем скореры
    for(int i=0; i<7; i++)
    {
        sensor_info* info = (sensor_info*) sensors[i]->GetUserData();
        DrawCircle(sensors[i]->GetWorldCenter(),
                   sensors[i]->GetShapeList()->GetSweepRadius(),
                   b2Color(0.8,0.8,0.2), info->active);
        glColor3ub(244,244,244);
        char str[4];
        sprintf(str,"%d", info->multiplier);
        freetype::print(font,
                        sensors[i]->GetWorldCenter().x-8,
                        sensors[i]->GetWorldCenter().y-21,
                        str);
    }

    // рисуем мячи
    for(int k=0; k<balls_created; k++)
        DrawBall(ballBody[k]->GetWorldCenter(), ballBody[k]->GetShapeList()->GetSweepRadius(),
                 ballBody[k]->GetAngle());

    // рисуем баунсеры
    for(int i=0; i<numberAllStaticCircles; i++)
    {
        if(allStaticCircles[i]!=NULL)
            DrawCircle(allStaticCircles[i]->GetWorldCenter(),
                       allStaticCircles[i]->GetShapeList()->GetSweepRadius(),
                       b2Color(0.2,0.9,0.2), false);
    }



    // рисуем линии между квадрантерами
    for(int j=0; j<5; j++)
    {
        if(allDynamicSquares[j][0]!=NULL)
            DrawLine(allDynamicSquares[j][0]->GetWorldCenter(),allStaticCircles[2*j]->GetWorldCenter(),b2Color(0.95,0.95,0));
        if(allDynamicSquares[j][numberAllDynamicSquares[j]-1]!=NULL)
            DrawLine(allDynamicSquares[j][numberAllDynamicSquares[j]-1]->GetWorldCenter(),allStaticCircles[2*j+1]->GetWorldCenter(),b2Color(0.95,0.95,0));
        for(int i=0; i<numberAllDynamicSquares[j]-1; i++)
        {
            if(allDynamicSquares[j][i]!=NULL && allDynamicSquares[j][i+1]!=NULL)
            {
                DrawLine(allDynamicSquares[j][i]->GetWorldCenter(),allDynamicSquares[j][i+1]->GetWorldCenter(),b2Color(0.95,0.95,0));
            }
        }
    }
}

bool Table::IsGameOver()
{
    for(int k=0; k<balls_created; k++)
    {
        if(!CListen.IsShapesContact(sensorBody->GetShapeList(), ballBody[k]->GetShapeList()))
            return false;
    }
    return true;

}

void Table::Control(side ex_side)
{
    if(ex_side==sleft) lobeLeftUp=true;
    else if(ex_side==sright) lobeRightUp=true;
}

void Table::ControlLost(side ex_side)
{
    if(ex_side==sleft) lobeLeftUp=false;
    else if(ex_side==sright) lobeRightUp=false;
}

void Table::UpdateName(string ex_str)
{
    name_of_player=ex_str;
}

bool Table::CanIPlayOnThisTable()
{
    return !automatic;
}

void Table::Unset()
{
    score=0;
    for(int k=0; k<balls_created; k++)
        world->DestroyBody(ballBody[k]);
    balls_created=0;
//    for(int i=0; i<numberAllStaticCircles+1; i++)
//        world->DestroyJoint(joints[i]);
    for(int i=0; i<numberAllStaticCircles; i++)
        world->DestroyBody(allStaticCircles[i]);
    delete allStaticCircles;

    for(int j=0; j<5; j++)
    {
        for(int i=0; i<numberAllDynamicSquares[j]; i++)
        {
            // нельзя удалять уже удаленный
            if(allDynamicSquares[j][i]!=NULL)
                world->DestroyBody(allDynamicSquares[j][i]);
        }
        delete[] allDynamicSquares[j];
    }

    delete sensors;
}
