#ifndef TABLE_H_INCLUDED
#define TABLE_H_INCLUDED

#include "nehe_freetype.h"
#include <Box2D.h>
#include "Render.h"
#include "ContactListener.h"
#include <math.h>
#include <string>
#include "menu.h"
#include <iostream>
extern freetype::font_data font;
extern string str_score;
enum side
{
    sleft, sright
};

struct sensor_info
{
    public:
        bool active;
        int multiplier;
        bool ball_in_me;
        void clear(int number);
};

struct RandomDB
{
    int number_of_circle_bouncing;
    x_y allCircleStaticCoords[50];
    int randomers_sensors[7];

    float up;
    float lenght;
    float delta;
    RandomDB();
    ~RandomDB();
};

class Table
{
    private:
        int i;
        bool automatic;
        std::string name_of_player;
        int score;

        DebugDraw Draw;
        ContactListener CListen;
        //RandomDB randdb;

        bool lobeLeftUp;
        bool lobeRightUp;

        b2World* world;

        b2Body* groundBody;

        b2Body* body;

        b2Body* sensorBody;

        int balls_created;
        b2Body* ballBody[100];

        b2Body *lobeBodyForLeft;
        b2Body *lobeBodyForRight;

        b2Body *aiActionBodyLeft;
        b2Body *aiActionBodyRight;

        b2Body **allStaticCircles;
        int numberAllStaticCircles;
        b2Body **allDynamicSquares[5];
        int numberAllDynamicSquares[5];

        sensor_info sens_info[7];
        b2Body *sensors[7];
     public:
        Table(int i);
        ~Table();
        void Set(RandomDB* raddb, bool);
        void Unset();
        void Step(float32, int32);
        bool IsGameOver();
        void Control(side);
        void ControlLost(side);
        void UpdateName(string);
        bool CanIPlayOnThisTable();
        void Flush();
        int GetScore();
        void ToNull();
        void DrawObjects(int);
        void CreateBall();
};

inline int Table::GetScore()
{
    return score;
}

inline void Table::Flush()
{
    CListen.m_pointCount=0;
}

inline void Table::ToNull()
{
    score=0;
}

#endif // TABLE_H_INCLUDED
