#include <iostream>
#include <windows.h>
#include <gl/glut.h>
#include <Box2D.h>
#include <cstdio>
#include <fstream>

#include "nehe_freetype.h"
#include "Render.h"
#include "ContactListener.h"
#include "Table.h"
#include "menu.h"
#include "challenge.h"
#include "stars.h"
#include "scoresave.h"
#include <csetjmp>
static jmp_buf env;

enum GAME_MODE {NO_GAME, CHALLENGE, DUEL};

GAME_MODE CURRENT_MODE = NO_GAME;

enum DISPLAYS {DISPLAY, DISPLAYMENU, DISPLAYSTATISTICS};

DISPLAYS WHAT_PLAYER_SEE_NOW=DISPLAYMENU;

freetype::font_data font;

Table LeftPinball(0);
Table RightPinball(1);

    float32 StepTime=0.0001;
	const int32 iters=10;

b2Color white(1,1,1);

ENTRY ENTRIES[10];

MENU MENU_ITEMS[10];
string menu[10];

string superstring;
string playernames[2];
bool FULLSCREEN = true;
string str_on, str_off, str_score, str_click, strangetext[4];

menu_list CURRENT_MENU = MENU_MAIN_MENU;

WinStars *stars;

RandomDB* randdb;

namespace botchallenge
{
    bool NEXT_FIGHT=false;
    int fights=0;
    int score=0;
}


// контролируем время
int past = 0;

void DisplayMenu(void);
void Display();
void DisplayStatistics(void);
void keyboard_ENTERING(unsigned char key, int x, int y);
void Keyboard(unsigned char key, int x, int y);
void mouse_GAMEOVER(int button, int state, int ex_x, int ex_y);
void mouse_EMPTY(int button, int state, int ex_x, int ex_y);
void mouse_MENU(int button, int state, int ex_x, int ex_y);
void DoIt(bool ex_whata);

void DoAction(int key)
{
    static int for_player=0;
    switch(key)
    {
        case 0: // выход
            longjmp(env, 1);
            break;
        case 1: // меняем Fullscreen
            FULLSCREEN = !FULLSCREEN;
            printf("load game again. thanks\n");
            longjmp(env, 1);
            break;
        case 2: // переименовать второго игрока
            for_player=1;
            superstring.erase();
            superstring.resize(25);
            glutMouseFunc(mouse_EMPTY);
            glutKeyboardFunc(keyboard_ENTERING);
            MENU_ITEMS[3].ChangeEnable(false);
            break;
        case 3: // переименовать первого игрока
            for_player=0;
            superstring.erase();
            superstring.resize(25);
            glutMouseFunc(mouse_EMPTY);
            glutKeyboardFunc(keyboard_ENTERING);
            MENU_ITEMS[4].ChangeEnable(false);
            break;
        case 4: // новая игра 1-1
            CURRENT_MENU = MENU_NOT_DISPLAYED;
            CURRENT_MODE = DUEL;
            {
                LeftPinball.Unset();
                RightPinball.Unset();
                delete stars;
                stars = new WinStars;
                delete randdb;
                randdb = new RandomDB;
                LeftPinball.Set(randdb, false);
                RightPinball.Set(randdb, false);
                LeftPinball.UpdateName(playernames[0]);
                RightPinball.UpdateName(playernames[1]);
            }
            glutDisplayFunc(Display);
            glutMouseFunc(mouse_EMPTY);
            DoIt(true);
            MENU_ITEMS[7].ChangeEnable(true);
            past=clock();
            break;
        case 5: // Челлендж
            botchallenge::fights=0;
            botchallenge::score=0;
            CURRENT_MENU = MENU_NOT_DISPLAYED;
            DoAction(12);
            MENU_ITEMS[7].ChangeEnable(true);

            break;
        case 6: // вернуться
            CURRENT_MENU = MENU_NOT_DISPLAYED;
            glutDisplayFunc(Display);
            break;
        case 7:
            if(CURRENT_MODE==NO_GAME)
            {
                CURRENT_MENU = MENU_NOT_DISPLAYED;
                glutDisplayFunc(DisplayStatistics);
                glutMouseFunc(mouse_GAMEOVER);
            }

            break;
        case 10: // выходим в меню
            //CURRENT_MODE = NO_GAME;
            CURRENT_MENU = MENU_MAIN_MENU;
            glutDisplayFunc(DisplayMenu);
            glutMouseFunc(mouse_MENU);
           // LeftPinball.ToNull();
           // RightPinball.ToNull();
            break;
        case 11: // апдейт имени
            if(for_player==1)
            {
                playernames[1]=superstring;
                MENU_ITEMS[3].Rename(menu[3]+playernames[1]);
                //LeftPinball.UpdateName(playernames[0]);
            }
            else if(for_player==0)
            {
                playernames[0]=superstring;
                MENU_ITEMS[4].Rename(menu[4]+playernames[0]);
                //RightPinball.UpdateName(playernames[1]);
            }
            break;
        case 12:
            CURRENT_MODE = CHALLENGE;
            {
                LeftPinball.Unset();
                RightPinball.Unset();
                delete stars;
                stars = new WinStars;
                delete randdb;
                randdb = new RandomDB;
                LeftPinball.Set(randdb, false);
                RightPinball.Set(randdb, true);
                LeftPinball.UpdateName(playernames[0]);
                RightPinball.UpdateName(GetMeRandomName());
            }
            glutDisplayFunc(Display);
            glutMouseFunc(mouse_EMPTY);
            DoIt(true);
            past=clock();
            break;
    }
}

void DisplayMenu(void)
{
    WHAT_PLAYER_SEE_NOW=DISPLAYMENU;
    glClearColor(0, 0, 0, 1);
    glClear(GL_COLOR_BUFFER_BIT);

    // включаем сглаживание кривых и точек
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_LINE_SMOOTH);
    glHint(GL_LINE_SMOOTH, GL_NICEST);
    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH, GL_NICEST);

    glColor3ub(255,255,255);
    freetype::print(font, 100, 300, strangetext[0].c_str());
    freetype::print(font, 100, 270, strangetext[1].c_str());
    freetype::print(font, 100, 240, strangetext[2].c_str());
    freetype::print(font, 100, 210, strangetext[3].c_str());

    for(int i=0; i<10; i++)
    {
        MENU_ITEMS[i].DrawMenu(CURRENT_MENU);
    }

    glutSwapBuffers();
}

void DoIt(bool ex_whata)
{
    static float countdown_time=0;
    if(ex_whata == true)
    {
        countdown_time=0;
        return;
    }
    //printf("%f\n",countdown_time);
    if(countdown_time>5.0)
    {
        //cout<<LeftPinball.GetScore()<<" "<<RightPinball.GetScore()<<endl;
        if(LeftPinball.GetScore() > RightPinball.GetScore())
        {
            stars->Draw(-512, -384, 0, 384, (int)(StepTime*1000));
            botchallenge::NEXT_FIGHT = true;
        }
        else if(LeftPinball.GetScore()<RightPinball.GetScore())
        {
            stars->Draw(0, -384, 512, 384, (int)(StepTime*1000));
            botchallenge::NEXT_FIGHT = false;
        }
        StepTime=0;
        glColor3ub(244,244,244);
        freetype::print(font, -100, 0, str_click.c_str());
        glutMouseFunc(mouse_GAMEOVER);
        // Определить победителя и рисовать картину радости
    }

    //когда StepTime =0, геймоверы всегда останутся тру чтобы не происходило,
    // и каунтдаун не обнулится
    LeftPinball.Step(StepTime, iters);
    RightPinball.Step(StepTime, iters);

    if(LeftPinball.IsGameOver() && RightPinball.IsGameOver())
    {
        countdown_time+=StepTime;
    }
    else
    {
        countdown_time=0;
    }
    // эти строчка должна быть в конце!!
    LeftPinball.Flush();
    RightPinball.Flush();
}

void Display(void)
{
    WHAT_PLAYER_SEE_NOW=DISPLAY;
    glClearColor(0, 0, 0, 1);
    glClear(GL_COLOR_BUFFER_BIT);

    // включаем сглаживание кривых и точек
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_LINE_SMOOTH);
    glHint(GL_LINE_SMOOTH, GL_NICEST);
    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH, GL_NICEST);

   // ("%d",m_points);
    DoIt(false);



//    glBegin(GL_QUADS);
//        glVertex2f(1,1);
//        glVertex2f(x,1);
//        glVertex2f(x,y);
//        glVertex2f(1,y);
//    glEnd();

    glutSwapBuffers();
}

void DisplayStatistics(void)
{
    WHAT_PLAYER_SEE_NOW=DISPLAYSTATISTICS;
    glClearColor(0, 0, 0, 1);
    glClear(GL_COLOR_BUFFER_BIT);

    // включаем сглаживание кривых и точек
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glEnable(GL_LINE_SMOOTH);
    glHint(GL_LINE_SMOOTH, GL_NICEST);
    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH, GL_NICEST);

    glColor3ub(255,255,244);
    for(int i=0; i<10; i++)
    {
        ENTRIES[i].Draw(i+1,-200,300-20*i);
    }

    glutSwapBuffers();
}

void Reshape(GLint w, GLint h)
{
    glViewport(0, 0, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(-512, 512, -384, 384, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
}

void Idle()
{
    int curr = clock();
    if(curr-past>0) StepTime = (curr-past)/1000.0;
    else StepTime = 0;
    past=curr;

    glutPostRedisplay();
}

void mouse_GAMEOVER(int button, int state, int ex_x, int ex_y)
{
    if(state==GLUT_DOWN)
    {
        if(CURRENT_MODE==DUEL)
        {
            MENU_ITEMS[7].ChangeEnable(false);
            DoAction(10);
        }
        else if(CURRENT_MODE==CHALLENGE)
        {
            if(WHAT_PLAYER_SEE_NOW==DISPLAY)
            {
                botchallenge::fights++;
                botchallenge::score+=LeftPinball.GetScore();
                if(botchallenge::NEXT_FIGHT)
                {
                    DoAction(12);
                }
                else
                {
                    EnterEntry(playernames[0].c_str(), botchallenge::fights, botchallenge::score);
                    glutDisplayFunc(DisplayStatistics);
                }
            }
            else
            {
                MENU_ITEMS[7].ChangeEnable(false);
                DoAction(10);
            }
        }
        else if(WHAT_PLAYER_SEE_NOW==DISPLAYSTATISTICS)
        {
            DoAction(10);
        }
    }
}

void mouse_EMPTY(int button, int state, int ex_x, int ex_y)
{
    // EMPTY;
}

void mouse_MENU(int button, int state, int ex_x, int ex_y)
{
    if(button==GLUT_LEFT_BUTTON && state==GLUT_DOWN)
    {
        float y=768-ex_y-384;
        float x=ex_x-512;
        for(int i=0; i<10; i++)
        {
            if(MENU_ITEMS[i].CheckMenu(x,y, CURRENT_MENU))
            {
                DoAction(MENU_ITEMS[i].GetCommand());
                break;
            }
        }
    }
}

void passivemotion_MENU(int ex_x, int ex_y)
{
    float y=768-ex_y-384;
    float x=ex_x-512;
    for(int i=0; i<10; i++)
    {
        MENU_ITEMS[i].CheckMenu(x,y, CURRENT_MENU);
    }
}

void Keyboard(unsigned char key, int x, int y)
{
    switch(key)
    {
        case 27:
            DoAction(10);
            break;
        case 'z': case 'Z':
        LeftPinball.Control(sleft);
        break;
        case 'c': case 'C':
        LeftPinball.Control(sright);
        break;
    }
}

void keyboard_ENTERING(unsigned char key, int x, int y)
{
    static int letter=0;
    if(key==27)
    {
        glutKeyboardFunc(Keyboard);
        glutMouseFunc(mouse_MENU);
        return;
    }
    else if(key==13) //enter
    {
        glutKeyboardFunc(Keyboard);
        glutMouseFunc(mouse_MENU);
        letter=0;
        MENU_ITEMS[3].ChangeEnable(true);
        MENU_ITEMS[4].ChangeEnable(true);
    }
    else if(key==8)
    {
        if(letter>0 && letter<50) superstring[--letter]='\0';
    }
    else
    {
        superstring[letter]=key;
        superstring[++letter]='\0';
    }
    DoAction(11);
}

void KeyboardUp(unsigned char key, int x, int y)
{
    switch(key)
    {
        case 'z': case 'Z':
        LeftPinball.ControlLost(sleft);
        break;
        case 'c': case 'C':
        LeftPinball.ControlLost(sright);
        break;
    }
}

void Special(int key, int x, int y)
{
    if(RightPinball.CanIPlayOnThisTable())
    {
        switch(key)
        {
            case GLUT_KEY_LEFT:
            RightPinball.Control(sleft);
            break;
            case GLUT_KEY_RIGHT:
            RightPinball.Control(sright);
            break;
        }
    }
}

void SpecialUp(int key, int x, int y)
{
    if(RightPinball.CanIPlayOnThisTable())
    {
        switch(key)
        {
            case GLUT_KEY_LEFT:
            RightPinball.ControlLost(sleft);
            break;
            case GLUT_KEY_RIGHT:
            RightPinball.ControlLost(sright);
            break;
        }
    }
}

int main(int argc, char** argv)
{
	//printf("%f", atan(80/192.0));
    srand(time(NULL));

    randdb = new RandomDB;
    LeftPinball.Set(randdb, false);
    RightPinball.Set(randdb, false);

    // на всякий случай инициализуем
    LoadKeyboardLayout("0x0000409", KLF_ACTIVATE);

    {
        int success=0;

        ifstream file("menunames.data", ios::in);
        if(!file)
        {
            cout<<"File menu don't open"<<endl;
            exit(1);
        }
        while(!file.eof())
        {
            getline(file, menu[success]);
            success++;
            if(success==10) break;
        }
        file.close();

        ifstream file2("players.data", ios::in);
        if(!file2)
        {
            cout<<"File players don't open"<<endl;
            exit(2);
        }

        getline(file2, playernames[0]);
        getline(file2, playernames[1]);
        string tempic;
        getline(file2, tempic);
        if(tempic=="1") FULLSCREEN=true;
        else if(tempic=="0") FULLSCREEN=false;
        file2.close();

        ifstream file3("words.data", ios::in);
        if(!file3)
        {
            cout<<"File players don't open"<<endl;
            exit(2);
        }

        getline(file3, str_on);
        getline(file3, str_off);
        getline(file3, str_score);
        getline(file3, str_click);
        getline(file3, strangetext[0]);
        getline(file3, strangetext[1]);
        getline(file3, strangetext[2]);
        getline(file3, strangetext[3]);
        file3.close();

        LoadEntries();

        // вернуться
        MENU_ITEMS[7].CreateMenu(MENU_MAIN_MENU, 6, -200, -160, menu[7]);
        MENU_ITEMS[7].ChangeEnable(false);
        // new game ai
        MENU_ITEMS[6].CreateMenu(MENU_MAIN_MENU, 5, -200, -180, menu[6]);
        // new game 1-1
        MENU_ITEMS[5].CreateMenu(MENU_MAIN_MENU, 4, -200, -200, menu[5]);

        // name 1
        MENU_ITEMS[4].CreateMenu(MENU_MAIN_MENU, 3, -200, -240, menu[4] + playernames[0]);
        // name 2
        MENU_ITEMS[3].CreateMenu(MENU_MAIN_MENU, 2, -200, -260, menu[3] + playernames[1]);

        // statistics
        MENU_ITEMS[2].CreateMenu(MENU_MAIN_MENU, 7, -200, -220, menu[2]);

        // fullscreen
        if(FULLSCREEN)
            MENU_ITEMS[1].CreateMenu(MENU_MAIN_MENU, 1, -200, -280, menu[1]+str_on);
        else
            MENU_ITEMS[1].CreateMenu(MENU_MAIN_MENU, 1, -200, -280, menu[1]+str_off);
        // quit
        MENU_ITEMS[0].CreateMenu(MENU_MAIN_MENU, 0, -200, -300, menu[0]);
    }


    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
    glutInitWindowSize(1024, 768);

    if(FULLSCREEN)
    {
        glutGameModeString("1024x768:32@60");
        glutEnterGameMode();
    }
    else glutCreateWindow("Random Pinball Masters 2D v0.1");

    font.init("font.ttf", 16);

    glutDisplayFunc(DisplayMenu);
    glutIdleFunc(Idle);
    glutReshapeFunc(Reshape);
    glutKeyboardFunc(Keyboard);
    glutSpecialFunc(Special);
    glutKeyboardUpFunc(KeyboardUp);
    glutSpecialUpFunc(SpecialUp);
    glutMouseFunc(mouse_MENU);
    glutPassiveMotionFunc(passivemotion_MENU);

    if(!setjmp(env)) glutMainLoop();

    ofstream savenames("players.data");
    savenames<<playernames[0]<<"\n"<<playernames[1]<<"\n";
    savenames<<(int)FULLSCREEN<<endl;
    savenames.close();

    SaveEntries();
	return 0;
}
