#include "menu.h"

color::color()
{
    doitgrey(0);
}

void color::change(unsigned char r, unsigned char g, unsigned char b)
{
    this->r=r;
    this->g=g;
    this->b=b;
}

void color::doitgrey(unsigned char i)
{
    r=g=b=i;
}

void color::activate()
{
    glColor3ub(r,g,b);
}

MENU::MENU()
{
    screen=MENU_NOT_EXIST;
    off_color.change(150,100,100);
    non_active_color.doitgrey(255);
    active_color.doitgrey(100);
    mouse_on=false;
    enable=true;
    translate=false;
    on=false;
    command=0;
}

void MENU::CreateMenu(menu_list ex_screen, int ex_command, float ex_x_begin_draw, float ex_y_begin_draw, string ex_word)
{
    screen=ex_screen;
    begin_draw_text.x=ex_x_begin_draw;
    begin_draw_text.y=ex_y_begin_draw;
    word=ex_word;
    command=ex_command;
    on=true;
}

void MENU::CreateMenu(menu_list ex_screen, int ex_command, float ex_x_begin_draw, float ex_y_begin_draw, string ex_word, bool ex_translate)
{
    screen=ex_screen;
    begin_draw_text.x=ex_x_begin_draw;
    begin_draw_text.y=ex_y_begin_draw;
    word=ex_word;
    command=ex_command;
    on=true;
    translate=ex_translate;
}

void MENU::Rename(string ex_word)
{
    word=ex_word;
}

void MENU::On()
{
    on=true;
}

void MENU::Off()
{
    on=false;
}

bool MENU::GetTranslateStatus()
{
    return translate;
}

string MENU::GetWordToTranslate()
{
    return word;
}

bool MENU::CheckMenu(float x, float y, menu_list ex_screen)
{
   // y=window_height-y;
    if(screen==MENU_NOT_EXIST || enable==false || on == false) return false;
    else if(screen==ex_screen)
    {
        freetype::size_text_data(font,word.c_str(),end_draw_text.x,end_draw_text.y);

        if(x>begin_draw_text.x && x<begin_draw_text.x+end_draw_text.x && y>begin_draw_text.y && y<begin_draw_text.y+end_draw_text.y)
        {
            ChangeMouseOn(true);
            return true;
        }
        ChangeMouseOn(false);
        return false;

    }
    return false;
}
void MENU::DrawMenu(menu_list ex_screen)
{
    if(screen==MENU_NOT_EXIST || on == false) return;
    else
    {
        if(enable)
            {
                if(mouse_on)
                {
                    active_color.activate();
                }
                else
                {
                    non_active_color.activate();
                }
            }
            else
            {
                off_color.activate();
            }

    if(screen==ex_screen)
    {
        freetype::print(font,begin_draw_text.x,begin_draw_text.y, word.c_str());

        //проверка поверхности, поля на котором находить мышь
//        glBegin(GL_POLYGON);
//
//            glColor3ub(200,200,255);
//            glVertex2f(begin_draw_text.x,begin_draw_text.y);
//            glVertex2f(begin_draw_text.x, begin_draw_text.y+end_draw_text.y);
//            glVertex2f(begin_draw_text.x+end_draw_text.x, begin_draw_text.y+end_draw_text.y);
//            glVertex2f(begin_draw_text.x+end_draw_text.x, begin_draw_text.y);
//        glEnd();
    }
    }
}
void MENU::ChangeEnable(bool b_var)
{
    enable=b_var;
}
void MENU::ChangeMouseOn(bool b_var)
{
    mouse_on=b_var;
}

int MENU::GetCommand()
{
    return command;
}
