#ifndef MENU_H_INCLUDED
#define MENU_H_INCLUDED

#include <windows.h>
#include <gl/glut.h>
#include <string>
#include "nehe_freetype.h"

extern freetype::font_data font;

enum menu_list {MENU_NOT_EXIST, MENU_NOT_DISPLAYED, MENU_MAIN_MENU};

struct x_y
{
    float x;
    float y;
};

struct color
{
    unsigned char r,g,b;
    color();
    void change(unsigned char r, unsigned char g, unsigned char b);
    void doitgrey(unsigned char i);
    void activate();
};

using namespace std;
class MENU
{
    private:
        bool on;
        bool mouse_on;
        bool enable;
        bool translate;
        menu_list screen;
        color non_active_color;
        color off_color;
        color active_color;
        x_y begin_draw_text;
        x_y end_draw_text;
        string word;
        int command;
        void ChangeMouseOn(bool);
    public:
        MENU();
        void CreateMenu(menu_list ex_screen, int, float ex_x_begin_draw, float ex_y_begind_draw, string word, bool);
        void CreateMenu(menu_list ex_screen, int, float ex_x_begin_draw, float ex_y_begind_draw, string word);
        void Rename(string word);
        string GetWordToTranslate();
        bool GetTranslateStatus();
        void DrawMenu(menu_list);
        bool CheckMenu(float x, float y, menu_list);
        void ChangeEnable(bool);
        void On();
        void Off();
        int GetCommand();
};

#endif // MENU_H_INCLUDED
