#include "stars.h"
Star::Star()
{
	r=1;
	g=1;
	b=0.3+rand()*0.7/RAND_MAX;
	size=rand()*0.3/RAND_MAX;
	width=1;
	height=1;
	down=0;
	up=1;
	choose_position(0,0,1,1);
	angle=rand()*M_2_PI/RAND_MAX;
}

Star::Star(float lx, float ly, float rx, float ry)
{
	r=1;
	g=1;
	b=0.3+rand()*0.7/RAND_MAX;
	width=rx-lx;
	height=ry-ly;
	down=ly;
	up=ry;
	choose_position(lx,ly,rx,ry);
	angle=rand()*M_2_PI/RAND_MAX;
	if(width<height){
		size=rand()*(width)/RAND_MAX/10;
	}
	else {
		size=rand()*(height)/RAND_MAX/10;
	}
}

void Star::SetParameters(float lx, float ly, float rx, float ry)
{
	r=1;
	g=1;
	width=rx-lx;
	height=ry-ly;
	up=ry;
	down=ly;
	b=0.3+rand()*0.7/RAND_MAX;
	choose_position(lx,ly,rx,ry);
	angle=rand()*M_2_PI/RAND_MAX;
	if(width<height){
		size=rand()*(width)/RAND_MAX/20;
	}
	else {
		size=rand()*(height)/RAND_MAX/20;
	}
}

void Star::DrawStar(int period)
{
	if(y>down+0.01*height)
	{
		angle+=size/20*period;
		y-=height/10000*period;
	}
	if(y<up) {
		//собственно, рисовние звезды.
		glColor3f(r,g,b);
		float delta=36*M_PI/180;
		glBegin(GL_LINE_LOOP);
		for(float d=angle;d<10*delta+angle;d+=delta*2){
			glVertex2f(x+size*cos(d),y+size*sin(d));
			glVertex2f(x+(size/4)*cos(d+delta),y+(size/4)*sin(d+delta));
		}
		glEnd();
	}
}

WinStars::WinStars()
{
    inited=false;
    stars=NULL;
}

void WinStars::Draw(float lx, float ly, float rx, float ry, int period)
{
    if(inited)
    {
        for(int i=0; i<50; i++)
            stars[i].DrawStar(period);
    }
    else
    {
        inited = true;
        stars = new Star[50];
        for(int i=0; i<50; i++)
            stars[i].SetParameters(lx,ly,rx,ry);
    }
}

void WinStars::Delete()
{
    inited = false;
    delete[] stars;
    stars = NULL;
}
