unit mytex;

interface
  uses OpenGL, eXgine, Windows, pngimage;

function Load(FileName: PChar; var W, H, BPP: integer; Clamp: Boolean = False; MipMap: Boolean = True; Group: Integer = 0): TTexture;

implementation

function Load(FileName: PChar; var W, H, BPP: integer; Clamp, MipMap: Boolean; Group: Integer): TTExture;
const
  LoadFromResource = false;
var
  Data : Array of DWORD;
  i, Width : Integer;
  j, Height : Integer;
  AlphaPtr: PByte;
  oPNG : TPngObject;
begin

  oPNG := TPngObject.Create;
  oPNG.LoadFromFile(Filename);

  if oPNG.Header.ColorType = COLOR_PALETTE then
    begin
      oPNG.free;
      exit;
    end;

  Width := oPNG.Width;
  Height := oPNG.Height;
  SetLength(Data, Width * Height);

  if (oPNG.Header.ColorType = COLOR_RGB) or
     (oPNG.Header.ColorType = COLOR_GRAYSCALE) then
  begin
    For j := 0 to Height - 1 do
      For i := 0 to Width - 1 do
        Data[i + (j * Width)] := $FF000000 or oPNG.Pixels[i, (Height-1)-j];
  end else
  if (oPNG.Header.ColorType = COLOR_RGBALPHA) or
     (oPNG.Header.ColorType = COLOR_GRAYSCALEALPHA) then
  begin
    for j := 0 to Height - 1 do
    begin
      AlphaPtr := PByte(oPNG.AlphaScanline[(Height-1)-j]);
      for i := 0 to Width - 1 do
      begin
        Data[i + (j * Width)] := (($FF000000 and (AlphaPtr^ shl 24)) or oPNG.Pixels[i, (Height-1)-j]);
        Inc(AlphaPtr);
      end;
    end;
  end;

  oPNG.free;

  W := Width;
  H := Height;
  BPP := 32;

  Result := tex.Create(FileName, GL_RGBA8, GL_RGBA, Width, Height, @Data[0], Clamp, MipMap, Group);
end;


end.
